"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyncJsonFileAdapter = exports.JsonFileAdapter = void 0;
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var fs_help_1 = require("./fs_help");
var JsonFileAdapter = (function () {
    function JsonFileAdapter(path, settings) {
        if (settings === void 0) { settings = {}; }
        this.path = path;
        this.settings = createDefaultSettings(settings);
    }
    JsonFileAdapter.prototype.save = function (data) {
        var _this = this;
        return new Promise(function (rs, rj) {
            return fs_help_1.mkdirs(path.dirname(_this.path)).then(function () {
                return fs.writeFile(_this.path, generateJson(data, _this.settings), function (err) {
                    if (err)
                        rj(err);
                    else
                        rs();
                });
            });
        });
    };
    JsonFileAdapter.prototype.load = function () {
        var _this = this;
        return new Promise(function (rs, rj) {
            fs.exists(_this.path, function (exists) {
                if (exists) {
                    fs.readFile(_this.path, function (err, data) {
                        if (err)
                            rj(err);
                        else
                            rs(JSON.parse(data.toString()));
                    });
                }
                else
                    rs({});
            });
        });
    };
    return JsonFileAdapter;
}());
exports.JsonFileAdapter = JsonFileAdapter;
var SyncJsonFileAdapter = (function () {
    function SyncJsonFileAdapter(path, settings) {
        if (settings === void 0) { settings = {}; }
        this.path = path;
        this.settings = createDefaultSettings(settings);
    }
    SyncJsonFileAdapter.prototype.save = function (data) {
        fs_help_1.mkdirsSync(path.dirname(this.path));
        fs.writeFileSync(this.path, generateJson(data, this.settings));
    };
    SyncJsonFileAdapter.prototype.load = function () {
        if (fs.existsSync(this.path))
            return JSON.parse(fs.readFileSync(this.path).toString());
        return {};
    };
    return SyncJsonFileAdapter;
}());
exports.SyncJsonFileAdapter = SyncJsonFileAdapter;
function generateJson(object, settings) {
    return settings.beautify ?
        JSON.stringify(object, null, settings.beautify_space) :
        JSON.stringify(object);
}
function createDefaultSettings(settings) {
    settings.beautify = settings.beautify || false;
    settings.beautify_space = settings.beautify_space || 2;
    return settings;
}
