"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyncYamlFileAdapter = exports.YamlFileAdapter = void 0;
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var fs_help_1 = require("./fs_help");
var yaml;
try {
    yaml = require('js-yaml');
}
catch (e) {
    var err = new Error("You should have installed js-yaml if you want to use the yaml-adapter");
    err.stack += '\nCaused by: ' + err.message + err.stack;
    throw e;
}
var YamlFileAdapter = (function () {
    function YamlFileAdapter(path) {
        this.path = path;
    }
    YamlFileAdapter.prototype.save = function (data) {
        var _this = this;
        return new Promise(function (rs, rj) {
            return fs_help_1.mkdirs(path.dirname(_this.path)).then(function () {
                return fs.writeFile(_this.path, yaml.dump(data), function (err) {
                    if (err)
                        rj(err);
                    else
                        rs();
                });
            });
        });
    };
    YamlFileAdapter.prototype.load = function () {
        var _this = this;
        return new Promise(function (rs, rj) {
            fs.exists(_this.path, function (exists) {
                if (exists) {
                    fs.readFile(_this.path, function (err, data) {
                        if (err)
                            rj(err);
                        else
                            rs(yaml.load(data.toString()));
                    });
                }
                else
                    rs({});
            });
        });
    };
    return YamlFileAdapter;
}());
exports.YamlFileAdapter = YamlFileAdapter;
var SyncYamlFileAdapter = (function () {
    function SyncYamlFileAdapter(path) {
        this.path = path;
    }
    SyncYamlFileAdapter.prototype.save = function (data) {
        fs_help_1.mkdirsSync(path.dirname(this.path));
        fs.writeFileSync(this.path, yaml.dump(data));
    };
    SyncYamlFileAdapter.prototype.load = function () {
        if (fs.existsSync(this.path))
            return yaml.load(fs.readFileSync(this.path).toString());
        return {};
    };
    return SyncYamlFileAdapter;
}());
exports.SyncYamlFileAdapter = SyncYamlFileAdapter;
